' *******************************************************************************************************
' *                                                                                                     *
' *     AiChip_TvText_Demo_002.spin                                                                     *
' *                                                                                                     *
' *******************************************************************************************************

CON

  _CLKMODE                      = XTAL1 + PLL16x
  _XINFREQ                      = 5_000_000                                           

  TV_PIN                        = 12
  
' TV_MODE                       = io#TV_MODE_NTSC + io#TV_MODE_LARGE_FONT
  TV_MODE                       = io#TV_MODE_NTSC + io#TV_MODE_SMALL_FONT +io#TV_MODE_FONT_0
' TV_MODE                       = io#TV_MODE_NTSC + io#TV_MODE_SMALL_FONT +io#TV_MODE_FONT_1

' TV_MODE                       = io#TV_MODE_PAL  + io#TV_MODE_LARGE_FONT   
' TV_MODE                       = io#TV_MODE_PAL  + io#TV_MODE_SMALL_FONT +io#TV_MODE_FONT_0 ' Not avail
' TV_MODE                       = io#TV_MODE_PAL  + io#TV_MODE_SMALL_FONT +io#TV_MODE_FONT_1 ' Not avail

' *******************************************************************************************************
' *                                                                                                     *
' *     Main Program. No need to edit below here, just change settings above                            *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  io                            : "AiChip_IoHandler_002"

CON

' .-----------------------------------------------------------------------------------------------------.
' |                                                                                                     |
' |     Device Routing                                                                                  |
' |                                                                                                     |
' `-----------------------------------------------------------------------------------------------------'
 
  ROUTE_NONE                    = io#ROUTE_NONE
  ROUTE_RX                      = io#ROUTE_RX
  ROUTE_TX                      = io#ROUTE_TX
  ROUTE_TV                      = io#ROUTE_TV
  ROUTE_LCD                     = io#ROUTE_LCD
  ROUTE_USB                     = io#ROUTE_USB

' .-----------------------------------------------------------------------------------------------------.
' |                                                                                                     |
' |     TV Modes                                                                                        |
' |                                                                                                     |
' `-----------------------------------------------------------------------------------------------------'

  TV_MODE_NTSC                  = io#TV_MODE_NTSC
  TV_MODE_PAL                   = io#TV_MODE_PAL

  TV_MODE_LARGE_FONT            = io#TV_MODE_LARGE_FONT
  TV_MODE_SMALL_FONT            = io#TV_MODE_SMALL_FONT

  TV_MODE_FAST_UPDATE           = io#TV_MODE_FAST_UPDATE
  TV_MODE_FLICKER_FREE          = io#TV_MODE_FLICKER_FREE

  TV_MODE_COLOR                 = io#TV_MODE_COLOR
  TV_MODE_COLOUR                = io#TV_MODE_COLOUR
  TV_MODE_MONOCHROME            = io#TV_MODE_MONOCHROME
  
  TV_MODE_INTERLACED            = io#TV_MODE_INTERLACED
  TV_MODE_NON_INTERLACED        = io#TV_MODE_NON_INTERLACED

  TV_MODE_COMPOSITE             = io#TV_MODE_COMPOSITE
  TV_MODE_BASEBAND              = io#TV_MODE_BASEBAND
  TV_MODE_BROADCAST             = io#TV_MODE_BROADCAST

  TV_MODE_RUNNING               = io#TV_MODE_RUNNING
  
' .-----------------------------------------------------------------------------------------------------.
' |                                                                                                     |
' |     Standard ASCII characters                                                                       |
' |                                                                                                     |
' `-----------------------------------------------------------------------------------------------------'

  CR                            = $0D
  LF                            = $0A

' *******************************************************************************************************
' *                                                                                                     *
' *     Demonstration Program                                                                           *
' *                                                                                                     *
' *******************************************************************************************************

VAR

  long tvKickCount
   
PUB Demo

  Demo_Tv(String("AiChip_TvText_Demo_001"))
  
  PauseMs( 10000 )
  repeat
    Kick_Tv( tvKickCount++ )
    PauseMs( 1000 )
        
PRI Demo_Tv( description ) | n, charNum

  result := Open( ROUTE_TV, TV_PIN, TV_MODE )
  
  TxText(description)
  TxCrLf
  TxCrLf
  
  if result & TV_MODE_PAL
    TxText(String("PAL "))
  else
    TxText(String("NTSC "))

  if ( TV_MODE & TV_MODE_PAL ) <> ( result & TV_MODE_PAL )
    TxText(String("Only, "))
        
  if result & TV_MODE_NON_INTERLACED
    TxText(String("Non-Interlaced ( "))
  else
    TxText(String("Interlaced ( "))

  TxNumber(GetColumnCount)
  TxText(String(" x "))
  TxNumber(GetRowCount)
  TxText(String(" )",LF))
  
  if result & TV_MODE_BROADCAST
    TxText(String("Broadcast",LF))
  else
    TxText(String("Composite Video ( Baseband )",LF))

  if ( TV_MODE & TV_MODE_BROADCAST ) <> ( result & TV_MODE_BROADCAST )
    TxText(String("Only, "))

  if result & TV_MODE_SMALL_FONT
    TxText(String("Small Font, "))
  else
    TxText(String("Large Font, "))

  if result & TV_MODE_MONOCHROME
    TxText(String("Monochrome"))
  else
    TxNumber(GetColourCount)
    TxText(String(" Colour"))
    if GetColourCount <> 1
      TxByte("s")
      
  if result & TV_MODE_FLICKER_FREE
    TxText(String(", Flicker Free"))
  else
    TxText(String(", Fast Update"))

  TxCrLf
  TxCrLf
  
  repeat n from 0 to 15
    TxText(String("^F"))
    TxByte(n)
    TxNumber(n)
    TxByte(" ")
  TxText(String("^#F",LF,LF))

  charNum := 0
  repeat while GetCurrentRow < GetRowCount
    repeat GetColumnCount
      TxRawByte( charNum++ )
    TxCrLf

PRI Kick_Tv( n )

  Open( ROUTE_TV, TV_PIN, TV_MODE )

  if ( n > 0 ) and ( ( n // 40 ) == 0 )
    Cls

  TxText(String("^F"))
  TxByte( n >> 2 + 0 )
  TxNumberFormat( n, 10, 0)
  
  TxText(String("^F"))
  TxByte( n >> 2 + 1 )
  TxText(String("^C",8))
  TxNumberFormat( n & $FF, 16, 2 )
  
  TxText(String("^F"))
  TxByte( n >> 2 + 2)
  TxText(String("^C",14))
  TxNumberFormat( n & $FF , 2, 8 )
  
  TxText(String("^F"))
  TxByte( n >> 2 + 3 )
  TxText(String("^C",26))
  TxNumberFormat( n << 24, $80, 8 )
  
  TxCrLf

' *******************************************************************************************************
' *                                                                                                     *
' *     Timing Routines                                                                                 *
' *                                                                                                     *
' *******************************************************************************************************

PRI PauseMs( mS )

  waitcnt( ( clkfreq / 1000 ) * mS + cnt )

' *******************************************************************************************************
' *                                                                                                     *
' *     Vectors into the IO handler                                                                     *
' *                                                                                                     *
' *******************************************************************************************************

PUB Open( setDeviceType, setBasePin, setMode )
  io.Open( setDeviceType, setBasePin, setMode )

PUB Close( setDeviceType )
  io.Close( setDeviceType )

PUB Route( setDeviceType )
  result := io.Route( setDeviceType )

PUB GetMode( setDeviceType )
  result := io.GetMode( setDeviceType )
        
PUB TxText( txtPtr )
  io.TxText( txtPtr )

PUB TxByte( b )
  io.TxByte( b )
  
PUB TxRawByte( b )
  io.TxRawByte( b )

PUB TxCrLf
  io.TxCrLf
    
PUB Cls
  io.Cls
  
PUB Home
  io.Home
  
PUB TxTab
  io.TxTab
  
PUB TxBackSpace
  io.TxBackSpace

PUB TxNumberFormat( n, radix, width )
  io.TxNumberFormat( n, radix, width )
 
PUB TxNumber( n )
  io.TxNumber( n )

PUB RxByte( b ) : rxd
  rxd := io.RxByte

PUB RxFlush
  io.RxFlush

PUB RxIfAvailable : rxd
  rxd := io.RxIfAvailable
      
PUB GetColourCount
  result := io.GetColourCount

PUB GetColumnCount
  result := io.GetColumnCount

PUB GetRowCount
  result := io.GetRowCount
  
PUB GetCurrentColumn
  result := io.GetCurrentColumn
  
PUB GetCurrentRow
  result := io.GetCurrentRow
    
PUB SetPalette( ptrToPalette )
  io.SetPalette( ptrToPalette )
               
PUB SetPaletteColour( colorIdx, fore, back )
  io.SetPaletteColour( colorIdx, fore, back )

' *******************************************************************************************************
' *                                                                                                     *
' *     End of AiChip_TvText_Demo_002.spin                                                              *
' *                                                                                                     *
' *******************************************************************************************************